//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F4FABAB00C0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F4FABAB00C0.cm

//## begin module%3F4FABAB00C0.cp preserve=no
//## end module%3F4FABAB00C0.cp

//## Module: Bearden%3F4FABAB00C0; Package body
//## Subsystem: XSModel::Model::EmissionLines%3F4FA70400FF
//## Source file: /local/data/xerxes1/gordon/Xspec/src/XSModel/Model/EmissionLines/Bearden.cxx

//## begin module%3F4FABAB00C0.additionalIncludes preserve=no
//## end module%3F4FABAB00C0.additionalIncludes

//## begin module%3F4FABAB00C0.includes preserve=yes
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSUtil/FunctionUtils/FunctionUtility.h>
#include "XSContainer.h"
#include "XSstreams.h"
//## end module%3F4FABAB00C0.includes

// Bearden
#include <XSModel/Model/EmissionLines/Bearden.h>
//## begin module%3F4FABAB00C0.declarations preserve=no
//## end module%3F4FABAB00C0.declarations

//## begin module%3F4FABAB00C0.additionalDeclarations preserve=yes
//## end module%3F4FABAB00C0.additionalDeclarations


// Class Bearden 

//## begin Bearden::ELEMENT%3F589B4E01A1.attr preserve=no  private: static string {U} "ELEMENT"
string Bearden::s_ELEMENT = "ELEMENT";
//## end Bearden::ELEMENT%3F589B4E01A1.attr

//## begin Bearden::TRANS%3F589B700198.attr preserve=no  private: static string {U} "TRANS"
string Bearden::s_TRANS = "TRANS";
//## end Bearden::TRANS%3F589B700198.attr

//## begin Bearden::ENERGY%3F589B84004A.attr preserve=no  private: static string {U} "ENERGY"
string Bearden::s_ENERGY = "ENERGY";
//## end Bearden::ENERGY%3F589B84004A.attr

//## begin Bearden::WAVE%3F589B8B0061.attr preserve=no  private: static string {U} "WAVE"
string Bearden::s_WAVE = "WAVE";
//## end Bearden::WAVE%3F589B8B0061.attr

//## begin Bearden::colNames%3F589B98021E.attr preserve=no  private: static StringArray {U} 
StringArray Bearden::s_colNames;
//## end Bearden::colNames%3F589B98021E.attr

Bearden::Bearden()
  //## begin Bearden::Bearden%3F4FAEEC025A_const.hasinit preserve=no
  //## end Bearden::Bearden%3F4FAEEC025A_const.hasinit
  //## begin Bearden::Bearden%3F4FAEEC025A_const.initialization preserve=yes
  //## end Bearden::Bearden%3F4FAEEC025A_const.initialization
{
  //## begin Bearden::Bearden%3F4FAEEC025A_const.body preserve=yes
  s_colNames.push_back(s_ELEMENT);
  s_colNames.push_back(s_TRANS);
  s_colNames.push_back(s_ENERGY);
  s_colNames.push_back(s_WAVE);
  //## end Bearden::Bearden%3F4FAEEC025A_const.body
}

Bearden::Bearden(const Bearden &right)
  //## begin Bearden::Bearden%3F4FAEEC025A_copy.hasinit preserve=yes
  : LineList(right)
  //## end Bearden::Bearden%3F4FAEEC025A_copy.hasinit
  //## begin Bearden::Bearden%3F4FAEEC025A_copy.initialization preserve=yes
  //## end Bearden::Bearden%3F4FAEEC025A_copy.initialization
{
  //## begin Bearden::Bearden%3F4FAEEC025A_copy.body preserve=yes
  const string BeardenFile("Bearden.fits");
  string fullName = FunctionUtility::modelDataPath() + BeardenFile;
  fileName(fullName);  
  //## end Bearden::Bearden%3F4FAEEC025A_copy.body
}


Bearden::~Bearden()
{
  //## begin Bearden::~Bearden%3F4FAEEC025A_dest.body preserve=yes
  //## end Bearden::~Bearden%3F4FAEEC025A_dest.body
}



//## Other Operations (implementation)
LineList* Bearden::clone () const
{
  //## begin Bearden::clone%3F4FBF360252.body preserve=yes
  return new Bearden(*this);
  //## end Bearden::clone%3F4FBF360252.body
}

void Bearden::readData ()
{
  //## begin Bearden::readData%3F54BDE80317.body preserve=yes
  using namespace CCfits;
  if (!file())
  {
     throw RedAlert("Attempting to read from unopened Line List file.");
  }
  try
  {
     ExtHDU& data = file()->extension(1);
     long nRows = data.rows();
     if (!nRows)
     {
        string msg("Error finding required data in ext 1 of file: ");
        msg += fileName();
        throw FileFormatError(msg);        
     }
     data.readData(true, s_colNames);
     data.column(s_TRANS).read(m_trans, 1, nRows);
     data.column(s_ELEMENT).read(m_element, 1, nRows);
     string colToGet = isWave() ? s_WAVE : s_ENERGY;
     data.column(colToGet).read(m_energyWave, 1, nRows);
  }
  catch (FitsException&)
  {
     string msg("Error finding required data in ext 1 of file: ");
     msg += fileName();
     throw FileFormatError(msg);
  }
  //## end Bearden::readData%3F54BDE80317.body
}

void Bearden::report (std::ostream& os) const
{
  //## begin Bearden::report%3F54BDEF008C.body preserve=yes
  using namespace std;
  if (m_iRows.first == m_iRows.second)
  {
     tcout << "\n    No lines found in the specified range." <<std::endl;
  }
  else
  {
     for (size_t i=m_iRows.first; i<m_iRows.second; ++i)
     {
        os << right << setw(12) << "Bearden" << setw(7) << ":" <<
              setw(11) << fixed << showpoint << setprecision(4) <<
              m_energyWave[i] << setw(7) << m_element[i] << " " <<
              left << setw(20) << m_trans[i] << std::endl;
     }
  }
  //## end Bearden::report%3F54BDEF008C.body
}

void Bearden::findLines ()
{
  //## begin Bearden::findLines%3F58A4350290.body preserve=yes
  size_t sz = m_energyWave.size();
  Real low = energyRange().first;
  Real high = energyRange().second;
  m_iRows.first = 0, m_iRows.second = 0;
  bool isFound = false;
  // NOTE: This assumes wavelegnths are sorted in INCREASING order,
  //       energies are sorted in DECREASING order.
  // Finds m_iRows.first and m_iRows.second such that valid range  is [m_iRows.first, m_iRows.second),
  //   so for energy mode, m_iRows.first actually points to eHigh and m_iRows.second
  //   is one past eLow. 
  if (isWave())
  {
     for (size_t i=0; i<sz; ++i)
     {
        if (m_energyWave[i] >= low)
        {
           isFound = true;
           m_iRows.first = i;
           break;
        }
     }
     if (!isFound)
     {
        // All wavelengths are lower than the specified minimum.
        return;
     }
     m_iRows.second = m_iRows.first;
     for (size_t i=m_iRows.first; i<sz; ++i)
     {
        if (m_energyWave[i] <= high)
        {
           ++m_iRows.second;
        }
        else
        {
           break;
        }
     }
     // If All wavelengths are lower than the specified maximum,
     // then m_iRows.second = sz at this point.
  }
  else
  {
     for (size_t i=0; i<sz; ++i)
     {
        if (m_energyWave[i] <= high )
        {
           isFound = true;
           m_iRows.first = i;
           break;
        }
     }
     if (!isFound)
     {
        // All energies are higher than the specified maximum.
        return;
     }
     m_iRows.second = m_iRows.first;
     for (size_t i=m_iRows.first; i<sz; ++i)
     {
        if (m_energyWave[i] >= low)
        {
           ++m_iRows.second;
        }
        else
        {
           break;
        }
     }
  }
  //## end Bearden::findLines%3F58A4350290.body
}

// Additional Declarations
  //## begin Bearden%3F4FAEEC025A.declarations preserve=yes
  //## end Bearden%3F4FAEEC025A.declarations

//## begin module%3F4FABAB00C0.epilog preserve=yes
//## end module%3F4FABAB00C0.epilog
